#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       untitled.py
#       
#       Copyright 2010 phiradet <phiradet.bangcharoensap@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#import board.py
import subprocess
import usb
import time
import threading
import pylab
from matplotlib import *
#import win32api
#import win32pdhutil
#import win32con

####################################
#VENDOR_RQ_SET_LED    = 0
#VENDOR_RQ_GET_SWITCH = 1

GET_TURNDIRECT = 0
GET_FORWARD = 10
GET_BACKWARD = 20

pylab.ion()
myBoard = None
timefig = pylab.figure(1)
timesub = pylab.subplot(111)
x_data=[]
y_data=[]
lines = pylab.plot(x_data,y_data)
numData = 0
####################################
class Board:
	def __init__(self):
		#print "Looking for MCU board..."
		dev = self.find_board()
		if not dev: #raise "MCU board not found!"
			print "MCU board found"
			raw_input()
			exit(0)
		self.handle = dev.open()

	def find_board(self):
		board = None
		for bus in usb.busses():
			for dev in bus.devices:
				if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
					return dev
		return None

	'''def set_led(self,pin,val):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
		self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin)

	def get_switch(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH, 1)
		return buf[0]'''
    
	def get_port(self,portnum):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, portnum, 1)
		return buf[0]

class GetDataProcess(threading.Thread):
	def __init__(self,PID):
		self.PID = PID
		threading.Thread.__init__ ( self )
		if self.PID == GET_FORWARD:
			self.previousState_FORWARD = 0
		elif self.PID == GET_BACKWARD:
			self.previousState_BACKWARD = 0
		self.process = None
		tmp =  map(str.strip,open('config.ini','r').readlines())
		index = tmp.index('sensitivity')
		if self.PID == GET_TURNDIRECT:
			self.delayTime = float(tmp[index+1])
		else:
			self.delayTime = 0.1
	
	def run(self):
		while(True):
			time.sleep(self.delayTime)

			if self.PID == GET_TURNDIRECT:
				self.getTurnDirect()							#Get status of direction switch

			elif self.PID == GET_BACKWARD:
				self.portVal = myBoard.get_port(GET_BACKWARD)	#Get status of Break switch
				print "BACKWARD = "+str(self.portVal)
				if self.previousState_BACKWARD == 0 and self.portVal == 1:
					print "Hey i willl back"
					self.cmd = "Backward.exe BACKWARD"
					self.process = subprocess.Popen(self.cmd,stdin=subprocess.PIPE,stdout=subprocess.PIPE)
				elif self.previousState_BACKWARD == 1 and self.portVal==0:
					#self.process.kill()
					self.cmd = "Backward.exe STOP"
					self.process = subprocess.Popen(self.cmd,stdin=subprocess.PIPE,stdout=subprocess.PIPE)
				self.previousState_BACKWARD = self.portVal

			elif self.PID == GET_FORWARD:
				self.portVal = myBoard.get_port(GET_FORWARD)	#Get status of Forward switch
				print "FORWARD = "+str(self.portVal)
				if self.previousState_FORWARD == 0 and self.portVal == 1:
					print "Hey i willl up"
					self.cmd = "Forward.exe FORWARD"
					self.process = subprocess.Popen(self.cmd,stdin=subprocess.PIPE,stdout=subprocess.PIPE)
				elif self.previousState_FORWARD == 1 and self.portVal==0:
					#self.process.kill()
					self.cmd = "Forward.exe STOP"
					self.process = subprocess.Popen(self.cmd,stdin=subprocess.PIPE,stdout=subprocess.PIPE)
				self.previousState_FORWARD = self.portVal

					
	
	def getTurnDirect(self):
		global numData
		''' This function is designed to get current status of PORTC'''
		self.temp = []
		self.numToCode = {'left3':'A','left2':'B','left1':'C','right1':'D','right2':'E','right3':'F'}
		for self.portnum in (0,1,2,3,4,5):
			#Request to get current value from PC(portnum)
			'''if self.portnum in (0,2):	#If you wanted full option please remove this condition
				self.portVal = myBoard.get_port(GET_TURNDIRECT+self.portnum)
			else:
				self.portVal = 0'''
			self.portVal = myBoard.get_port(GET_TURNDIRECT+self.portnum)
			self.temp.append(self.portVal)
		print self.temp
		self.wantedDir = ''
		if self.temp == [1,0,1,0,1,0]:		#Turn left with very high angle
			self.wantedDir = 'left3'
			y_data.append(3)
		elif self.temp == [0,0,1,0,1,0]: 	#Turn left with high angle
			self.wantedDir = 'left2'
			y_data.append(2)
		elif self.temp == [0,1,1,0,1,0]: 	#Turn left with low angle
			self.wantedDir = 'left1'
			y_data.append(1)
		elif self.temp == [0,1,0,1,1,0]: 	#Turn right with low angle
			self.wantedDir = 'right1'
			y_data.append(-1)
		elif self.temp == [0,1,0,1,0,0]: 	#Turn right with high angle
			self.wantedDir = 'right2'
			y_data.append(-2)
		elif self.temp == [0,1,0,1,0,1]:	#Turn right with very high angle
			self.wantedDir = 'right3'
			y_data.append(-3)
		
		x_data.append(numData)
		numData+=1
		if not self.wantedDir:
			y_data.append(0)
		#if (self.delayTime>0.7) or (self.delayTime<=0.7 and numData%2==0):			
		lines[0].set_data(x_data,y_data)
		timesub.set_xlim(0,numData+10)
		timesub.set_ylim(-4,4)
		pylab.draw()
		'''if (not x_data) and len(x_data)>=40:
			x_data = x_data[1:]
			y_data = y_data[1:]'''
		print x_data
		#print self.temp
		if  self.wantedDir!='':
			self.cmd = "SendInput.exe "+self.numToCode[self.wantedDir]
			self.process = subprocess.Popen(self.cmd,stdin=subprocess.PIPE,stdout=subprocess.PIPE)
			#print "Hey I will: %s"%self.wantedDir
def main():
	global myBoard
	numToCode = {0:'A',1:'B',3:'C',4:'D'}
	oldState = 0
	myBoard = Board()
	while(True):
		temp = []
		time.sleep(0.5)
		#for portnum in range(5):
		for portnum in (1,3): #Test for PC1 and PC3
			result = myBoard.get_port(portnum)
			#temp.append("P("+str(portnum)+")="+str(result))
			temp.append(result)
			if result == 1 and portnum!= 0:
				cmd = "SendInput.exe "+numToCode[portnum]
				print cmd
				process = subprocess.Popen(cmd,stdin=subprocess.PIPE)
				print "Detected port = %d"%portnum
		print temp
	return 0

def mainThread():
	global myBoard
	myBoard = Board()
	
	allThread = []
	#for i in [GET_TURNDIRECT,GET_BACKWARD,GET_FORWARD]:#,GET_FORWARD,GET_BACKWARD]:
	#for i in [GET_BACKWARD,GET_FORWARD]:#,GET_FORWARD,GET_BACKWARD]:
	for i in [GET_TURNDIRECT]:
		s = GetDataProcess(i)
		allThread.append(s)
		s.start()
		#s.join()
	

if __name__ == '__main__':
	#main()
	mainThread()

